#include "stdafx.h"
#include "openttd.h"
#include "player.h"
#include "variables.h"
#include "subsidiaries.h"

/* Can be used even if _patches.subsidiaries is false */
PlayerID GetMotherCompany(const Player *p)
{
	int i;

	for(i=1;p->share_owners[i] == p->share_owners[0];) {
		if (++i == 4 && p->share_owners[0] != 0xFF) {
			return p->share_owners[0];
		}
	}

	return p->index;
}

bool IsSisterCompanyIgnorePatch(const PlayerID c1, const PlayerID c2)
{
	if(c1 > MAX_PLAYERS || c2 > MAX_PLAYERS)
			return false;
	return GetMotherCompany(GetPlayer(c1)) == GetMotherCompany(GetPlayer(c2));
}

bool IsSisterCompany(const PlayerID c1, const PlayerID c2)
{
	if (!_patches.subsidiaries){
		return c1 == c2;
	}else{
		if(c1 > MAX_PLAYERS || c2 > MAX_PLAYERS)
			return false;
		return GetMotherCompany(GetPlayer(c1)) == GetMotherCompany(GetPlayer(c2));
	}
}

bool IsSubsidiary(const Player *p)
{
	PlayerID playerOwner = GetMotherCompany(GetPlayer(_local_player));
	PlayerID paramOwner = GetMotherCompany(p);

	return (playerOwner == paramOwner);
}

byte GetSubsidiariesCount(void)
{
	Player *p;
	int count = 0;

	FOR_ALL_PLAYERS(p){
		if(p->is_active && IsSubsidiary(p))
			count++;
	}

	return count;
}

int32 GetSubsidiaries(void)
{
	int64 list = 0;
	int i = 0;
	Player *p;

	FOR_ALL_PLAYERS(p){
		if(p->is_active && IsSubsidiary(p)){
			list |= (int64)(1 << i);
		}
		i++;
	}

	return list;
}
